import * as i1 from '@angular-three/core';
import { NgtCommonCamera, NGT_OBJECT_CONTROLLER_PROVIDER, createParentObjectProvider, NgtObjectControllerModule, NGT_OBJECT_WATCHED_CONTROLLER } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Directive, Input, NgModule, EventEmitter, Inject, Output } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtCamera extends NgtCommonCamera {
    constructor() {
        super(...arguments);
        this.cameraType = THREE.Camera;
    }
    set args(v) {
        this.cameraArgs = v;
    }
}
NgtCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCamera, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtCamera, selector: "ngt-camera", inputs: { args: "args" }, providers: [
        {
            provide: NgtCommonCamera,
            useExisting: NgtCamera,
        },
        NGT_OBJECT_CONTROLLER_PROVIDER,
        createParentObjectProvider(NgtCamera, (parent) => parent.camera),
    ], exportAs: ["ngtCamera"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-camera',
                    exportAs: 'ngtCamera',
                    providers: [
                        {
                            provide: NgtCommonCamera,
                            useExisting: NgtCamera,
                        },
                        NGT_OBJECT_CONTROLLER_PROVIDER,
                        createParentObjectProvider(NgtCamera, (parent) => parent.camera),
                    ],
                }]
        }], propDecorators: { args: [{
                type: Input
            }] } });
class NgtCameraModule {
}
NgtCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCameraModule, declarations: [NgtCamera], exports: [NgtCamera, NgtObjectControllerModule] });
NgtCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCameraModule, imports: [NgtObjectControllerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtCamera],
                    exports: [NgtCamera, NgtObjectControllerModule],
                }]
        }] });

// GENERATED
class NgtPerspectiveCamera extends NgtCommonCamera {
    constructor() {
        super(...arguments);
        this.cameraType = THREE.PerspectiveCamera;
    }
    set args(v) {
        this.cameraArgs = v;
    }
}
NgtPerspectiveCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCamera, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtPerspectiveCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtPerspectiveCamera, selector: "ngt-perspective-camera", inputs: { args: "args" }, providers: [
        {
            provide: NgtCommonCamera,
            useExisting: NgtPerspectiveCamera,
        },
        NGT_OBJECT_CONTROLLER_PROVIDER,
        createParentObjectProvider(NgtPerspectiveCamera, (parent) => parent.camera),
    ], exportAs: ["ngtPerspectiveCamera"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-perspective-camera',
                    exportAs: 'ngtPerspectiveCamera',
                    providers: [
                        {
                            provide: NgtCommonCamera,
                            useExisting: NgtPerspectiveCamera,
                        },
                        NGT_OBJECT_CONTROLLER_PROVIDER,
                        createParentObjectProvider(NgtPerspectiveCamera, (parent) => parent.camera),
                    ],
                }]
        }], propDecorators: { args: [{
                type: Input
            }] } });
class NgtPerspectiveCameraModule {
}
NgtPerspectiveCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPerspectiveCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCameraModule, declarations: [NgtPerspectiveCamera], exports: [NgtPerspectiveCamera, NgtObjectControllerModule] });
NgtPerspectiveCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCameraModule, imports: [NgtObjectControllerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtPerspectiveCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtPerspectiveCamera],
                    exports: [NgtPerspectiveCamera, NgtObjectControllerModule],
                }]
        }] });

// GENERATED
class NgtOrthographicCamera extends NgtCommonCamera {
    constructor() {
        super(...arguments);
        this.cameraType = THREE.OrthographicCamera;
    }
    set args(v) {
        this.cameraArgs = v;
    }
}
NgtOrthographicCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCamera, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtOrthographicCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtOrthographicCamera, selector: "ngt-orthographic-camera", inputs: { args: "args" }, providers: [
        {
            provide: NgtCommonCamera,
            useExisting: NgtOrthographicCamera,
        },
        NGT_OBJECT_CONTROLLER_PROVIDER,
        createParentObjectProvider(NgtOrthographicCamera, (parent) => parent.camera),
    ], exportAs: ["ngtOrthographicCamera"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-orthographic-camera',
                    exportAs: 'ngtOrthographicCamera',
                    providers: [
                        {
                            provide: NgtCommonCamera,
                            useExisting: NgtOrthographicCamera,
                        },
                        NGT_OBJECT_CONTROLLER_PROVIDER,
                        createParentObjectProvider(NgtOrthographicCamera, (parent) => parent.camera),
                    ],
                }]
        }], propDecorators: { args: [{
                type: Input
            }] } });
class NgtOrthographicCameraModule {
}
NgtOrthographicCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtOrthographicCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCameraModule, declarations: [NgtOrthographicCamera], exports: [NgtOrthographicCamera, NgtObjectControllerModule] });
NgtOrthographicCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCameraModule, imports: [NgtObjectControllerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtOrthographicCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtOrthographicCamera],
                    exports: [NgtOrthographicCamera, NgtObjectControllerModule],
                }]
        }] });

// GENERATED
class NgtArrayCamera extends NgtCommonCamera {
    constructor() {
        super(...arguments);
        this.cameraType = THREE.ArrayCamera;
    }
    set args(v) {
        this.cameraArgs = v;
    }
}
NgtArrayCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCamera, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtArrayCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtArrayCamera, selector: "ngt-array-camera", inputs: { args: "args" }, providers: [
        {
            provide: NgtCommonCamera,
            useExisting: NgtArrayCamera,
        },
        NGT_OBJECT_CONTROLLER_PROVIDER,
        createParentObjectProvider(NgtArrayCamera, (parent) => parent.camera),
    ], exportAs: ["ngtArrayCamera"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-array-camera',
                    exportAs: 'ngtArrayCamera',
                    providers: [
                        {
                            provide: NgtCommonCamera,
                            useExisting: NgtArrayCamera,
                        },
                        NGT_OBJECT_CONTROLLER_PROVIDER,
                        createParentObjectProvider(NgtArrayCamera, (parent) => parent.camera),
                    ],
                }]
        }], propDecorators: { args: [{
                type: Input
            }] } });
class NgtArrayCameraModule {
}
NgtArrayCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtArrayCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCameraModule, declarations: [NgtArrayCamera], exports: [NgtArrayCamera, NgtObjectControllerModule] });
NgtArrayCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCameraModule, imports: [NgtObjectControllerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtArrayCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtArrayCamera],
                    exports: [NgtArrayCamera, NgtObjectControllerModule],
                }]
        }] });

// GENERATED
class NgtStereoCamera extends NgtCommonCamera {
    constructor() {
        super(...arguments);
        this.cameraType = THREE.StereoCamera;
    }
    set args(v) {
        this.cameraArgs = v;
    }
}
NgtStereoCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCamera, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtStereoCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtStereoCamera, selector: "ngt-stereo-camera", inputs: { args: "args" }, providers: [
        {
            provide: NgtCommonCamera,
            useExisting: NgtStereoCamera,
        },
        NGT_OBJECT_CONTROLLER_PROVIDER,
        createParentObjectProvider(NgtStereoCamera, (parent) => parent.camera),
    ], exportAs: ["ngtStereoCamera"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-stereo-camera',
                    exportAs: 'ngtStereoCamera',
                    providers: [
                        {
                            provide: NgtCommonCamera,
                            useExisting: NgtStereoCamera,
                        },
                        NGT_OBJECT_CONTROLLER_PROVIDER,
                        createParentObjectProvider(NgtStereoCamera, (parent) => parent.camera),
                    ],
                }]
        }], propDecorators: { args: [{
                type: Input
            }] } });
class NgtStereoCameraModule {
}
NgtStereoCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtStereoCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCameraModule, declarations: [NgtStereoCamera], exports: [NgtStereoCamera, NgtObjectControllerModule] });
NgtStereoCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCameraModule, imports: [NgtObjectControllerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStereoCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtStereoCamera],
                    exports: [NgtStereoCamera, NgtObjectControllerModule],
                }]
        }] });

class NgtCubeCamera {
    constructor(objectController) {
        this.objectController = objectController;
        this.ready = new EventEmitter();
        objectController.initFn = () => (this._cubeCamera = new THREE.CubeCamera(...this.args));
        objectController.readyFn = () => this.ready.emit(this.cubeCamera);
    }
    get cubeCamera() {
        return this._cubeCamera;
    }
    ngOnInit() {
        this.objectController.init();
    }
}
NgtCubeCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCamera, deps: [{ token: NGT_OBJECT_WATCHED_CONTROLLER }], target: i0.ɵɵFactoryTarget.Directive });
NgtCubeCamera.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtCubeCamera, selector: "ngt-cube-camera", inputs: { args: "args" }, outputs: { ready: "ready" }, providers: [NGT_OBJECT_CONTROLLER_PROVIDER], exportAs: ["ngtCubeCamera"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCamera, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-cube-camera',
                    exportAs: 'ngtCubeCamera',
                    providers: [NGT_OBJECT_CONTROLLER_PROVIDER],
                }]
        }], ctorParameters: function () {
        return [{ type: i1.NgtObjectController, decorators: [{
                        type: Inject,
                        args: [NGT_OBJECT_WATCHED_CONTROLLER]
                    }] }];
    }, propDecorators: { ready: [{
                type: Output
            }], args: [{
                type: Input
            }] } });
class NgtCubeCameraModule {
}
NgtCubeCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCubeCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCameraModule, declarations: [NgtCubeCamera], exports: [NgtCubeCamera] });
NgtCubeCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCameraModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtCubeCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtCubeCamera],
                    exports: [NgtCubeCamera],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtArrayCamera, NgtArrayCameraModule, NgtCamera, NgtCameraModule, NgtCubeCamera, NgtCubeCameraModule, NgtOrthographicCamera, NgtOrthographicCameraModule, NgtPerspectiveCamera, NgtPerspectiveCameraModule, NgtStereoCamera, NgtStereoCameraModule };
//# sourceMappingURL=angular-three-core-cameras.mjs.map
