import { ChangeDetectorRef, InjectionToken, OnChanges, Provider, SimpleChanges, Type } from '@angular/core';
import { Observable, ReplaySubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare abstract class Controller implements OnChanges {
    disabled: boolean;
    readonly changes$: ReplaySubject<SimpleChanges>;
    readyFn?: () => void;
    ngOnChanges(changes: SimpleChanges): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Controller, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<Controller, never, never, { "disabled": "disabled"; }, {}, never>;
}
export interface CreateControllerTokenFactoryOptions<TController extends Controller> {
    watchedControllerTokenName: string;
    controller: Type<TController>;
    newInstanceOnNull?: boolean;
}
export declare function controllerFactory<TController extends Controller>(newInstanceOnNull: boolean | undefined, controllerType: Type<TController>): (controller: TController | null, cdr: ChangeDetectorRef, destroyed: Observable<void>) => TController | null;
export declare function createControllerProviderFactory<TController extends Controller>({ watchedControllerTokenName, controller, newInstanceOnNull, }: CreateControllerTokenFactoryOptions<TController>): [
    InjectionToken<TController>,
    Provider[]
];
