import { InjectionToken, Type } from '@angular/core';
import * as THREE from 'three';
import type { AnyFunction } from '../types';
export declare const NGT_PARENT_OBJECT: InjectionToken<AnyFunction>;
export declare function createParentObjectProvider<TExisting extends Type<any>>(existing: TExisting, factory: (existing: InstanceType<TExisting>) => THREE.Object3D): {
    provide: InjectionToken<AnyFunction>;
    useFactory: (existing: InstanceType<TExisting>) => () => THREE.Object3D<THREE.Event>;
    deps: TExisting[];
};
export declare const NGT_HOST_PARENT_OBJECT: InjectionToken<AnyFunction>;
export declare function createHostParentObjectProvider<TExisting extends Type<any>>(existing: TExisting): {
    provide: InjectionToken<AnyFunction>;
    useFactory: (existing: InstanceType<TExisting> & {
        parentObjectFn: AnyFunction | null;
    }) => () => any;
    deps: TExisting[];
};
