import { ElementRef } from '@angular/core';
import { Observable } from 'rxjs';
import * as THREE from 'three';
import { NgtResizeResult } from '../services/resize';
import type { NgtCanvasState, NgtPerformanceOptions, NgtRaycaster } from '../types';
import { NgtStore } from './store';
import * as i0 from "@angular/core";
export declare class NgtCanvasStore extends NgtStore<NgtCanvasState> {
    private resizeResult$;
    readonly ready$: Observable<boolean>;
    readonly camera$: Observable<import("../types").NgtCamera>;
    readonly scene$: Observable<THREE.Scene>;
    readonly renderer$: Observable<THREE.WebGLRenderer>;
    readonly raycaster$: Observable<NgtRaycaster>;
    private allConstructed$;
    private dimensions$;
    constructor(performance: NgtPerformanceOptions, { nativeElement: { clientHeight, clientWidth }, }: ElementRef<HTMLElement>, resizeResult$: Observable<NgtResizeResult>, document: Document);
    readonly init: (observableOrValue: HTMLCanvasElement | Observable<HTMLCanvasElement>) => import("rxjs").Subscription;
    get isLinear(): boolean;
    private readonly resize;
    private readonly updateDimensions;
    private readonly initRenderer;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCanvasStore, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NgtCanvasStore>;
}
