import { EventEmitter, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtObjectController } from '../controllers/object.controller';
import type { AnyConstructor } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtCommonAudio<TAudioNode extends AudioNode = GainNode, TAudio extends THREE.Audio<TAudioNode> = THREE.Audio<TAudioNode>> implements OnInit {
    protected objectController: NgtObjectController;
    listener: THREE.AudioListener;
    ready: EventEmitter<TAudio>;
    private _audioArgs;
    protected set audioArgs(v: unknown | unknown[]);
    constructor(objectController: NgtObjectController);
    abstract audioType: AnyConstructor<TAudio>;
    _audio: TAudio;
    ngOnInit(): void;
    get audio(): TAudio;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCommonAudio<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCommonAudio<any, any>, never, never, { "listener": "listener"; }, { "ready": "ready"; }, never>;
}
