import { NgtCanvasStore, NgtCommonMesh, NgtMatrix4, NgtObjectController, NgtObjectInputsController, NgtStore } from '@angular-three/core';
import { EventEmitter, NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import * as i0 from "@angular/core";
import * as i1 from "@angular-three/core";
export declare class NgtSkinnedMesh extends NgtCommonMesh<THREE.SkinnedMesh> {
    set args(v: [boolean]);
    bindMatrix?: NgtMatrix4;
    bindMode?: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMesh, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtSkinnedMesh, "ngt-skinned-mesh", ["ngtSkinnedMesh"], { "args": "args"; "bindMatrix": "bindMatrix"; "bindMode": "bindMode"; }, {}, never>;
}
export declare class NgtSkeleton extends NgtStore implements OnInit {
    private zone;
    private canvasStore;
    private skinnedMesh;
    boneInverses?: NgtMatrix4[];
    ready: EventEmitter<THREE.Skeleton>;
    private _skeleton?;
    get skeleton(): THREE.Skeleton | undefined;
    constructor(zone: NgZone, canvasStore: NgtCanvasStore, skinnedMesh: NgtSkinnedMesh);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkeleton, [null, null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtSkeleton, "ngt-skeleton", ["ngtSkeleton"], { "boneInverses": "boneInverses"; }, { "ready": "ready"; }, never>;
}
export declare class NgtBone implements OnInit {
    private zone;
    private objectController;
    private objectInputsController;
    private parentSkinnedMesh;
    private parentSkeleton;
    ready: EventEmitter<THREE.Bone>;
    private _bone?;
    get bone(): THREE.Bone | undefined;
    constructor(zone: NgZone, objectController: NgtObjectController, objectInputsController: NgtObjectInputsController, parentSkinnedMesh: NgtSkinnedMesh, parentSkeleton: NgtSkeleton);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtBone, [null, null, null, { optional: true; }, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtBone, "ngt-bone", ["ngtBone"], {}, { "ready": "ready"; }, never>;
}
export declare class NgtSkinnedMeshModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMeshModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtSkinnedMeshModule, [typeof NgtSkinnedMesh, typeof NgtBone, typeof NgtSkeleton], never, [typeof NgtSkinnedMesh, typeof NgtBone, typeof NgtSkeleton, typeof i1.NgtMaterialGeometryControllerModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtSkinnedMeshModule>;
}
